Skip to content
Start here

Create a Page Shield policy

client.pageShield.policies.create(PolicyCreateParams { zone_id, action, description, 3 more } params, RequestOptionsoptions?): PolicyCreateResponse { id, action, description, 3 more } | null
POST/zones/{zone_id}/page_shield/policies

Create a Page Shield policy.

Security

API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Page ShieldDomain Page ShieldZone Settings Write
ParametersExpand Collapse
params: PolicyCreateParams { zone_id, action, description, 3 more }
zone_id: string

Path param: Identifier

maxLength32
action: "allow" | "log" | "add_reporting_directives"

Body param: The action to take if the expression matches

One of the following:
"allow"
"log"
"add_reporting_directives"
description: string

Body param: A description for the policy

enabled: boolean

Body param: Whether the policy is enabled

expression: string

Body param: The expression which must match for the policy to be applied, using the Cloudflare Firewall rule expression syntax

value: string

Body param: The policy which will be applied

ReturnsExpand Collapse
PolicyCreateResponse { id, action, description, 3 more }
id: string

Identifier

maxLength32
action: "allow" | "log" | "add_reporting_directives"

The action to take if the expression matches

One of the following:
"allow"
"log"
"add_reporting_directives"
description: string

A description for the policy

enabled: boolean

Whether the policy is enabled

expression: string

The expression which must match for the policy to be applied, using the Cloudflare Firewall rule expression syntax

value: string

The policy which will be applied

Create a Page Shield policy

import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiEmail: process.env['CLOUDFLARE_EMAIL'], // This is the default and can be omitted
  apiKey: process.env['CLOUDFLARE_API_KEY'], // This is the default and can be omitted
});

const policy = await client.pageShield.policies.create({
  zone_id: '023e105f4ecef8ad9ca31a8372d0c353',
  action: 'allow',
  description: 'Checkout page CSP policy',
  enabled: true,
  expression: 'ends_with(http.request.uri.path, "/checkout")',
  value: "script-src 'none';",
});

console.log(policy.id);
{
  "result": {
    "id": "023e105f4ecef8ad9ca31a8372d0c353",
    "action": "allow",
    "description": "Checkout page CSP policy",
    "enabled": true,
    "expression": "ends_with(http.request.uri.path, \"/checkout\")",
    "value": "script-src 'none';"
  },
  "success": true,
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ]
}
Returns Examples
{
  "result": {
    "id": "023e105f4ecef8ad9ca31a8372d0c353",
    "action": "allow",
    "description": "Checkout page CSP policy",
    "enabled": true,
    "expression": "ends_with(http.request.uri.path, \"/checkout\")",
    "value": "script-src 'none';"
  },
  "success": true,
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ]
}